Main Page | Namespace List | Class Hierarchy | Alphabetical List | Class List | File List | Namespace Members | Class Members | File Members | Related Pages

# osg::NodeVisitor Class Reference

Visitor for type safe operations on osg::Nodes. More...

Inheritance diagram for osg::NodeVisitor:

[legend]
List of all members.

## Public Types
enum | TraversalMode { TRAVERSE_NONE, TRAVERSE_PARENTS, TRAVERSE_ALL_CHILDREN, TRAVERSE_ACTIVE_CHILDREN }
enum | VisitorType { NODE_VISITOR = 0, UPDATE_VISITOR, EVENT_VISITOR, COLLECT_OCCLUDER_VISITOR, CULL_VISITOR }
## Public Member Functions
| NodeVisitor (TraversalMode tm=TRAVERSE_NONE)
| NodeVisitor (VisitorType type, TraversalMode tm=TRAVERSE_NONE)
virtual | ~NodeVisitor ()
virtual void | reset ()
| Method to call to reset visitor.
void | setVisitorType (VisitorType type)
| Set the VisitorType, used to distinguish different visitors during traversal of the scene, typically used in the Node::traverse() method to select which behaviour to use for different types of traversal/visitors.
VisitorType | getVisitorType () const
| Get the VisitorType.
void | setTraversalNumber (int fn)
| Set the traversal number.
int | getTraversalNumber () const
| Get the traversal number.
void | setFrameStamp (FrameStamp *fs)
| Set the FrameStamp that this traversal is associated with.
const FrameStamp * | getFrameStamp () const
| Get the FrameStamp that this traversal is associated with.
void | setTraversalMask (Node::NodeMask mask)
| Set the TraversalMask of this NodeVisitor.
Node::NodeMask | getTraversalMask () const
| Get the TraversalMask.
void | setNodeMaskOverride (Node::NodeMask mask)
| Set the NodeMaskOverride mask.
Node::NodeMask | getNodeMaskOverride () const
| Get the NodeMaskOverride mask.
bool | validNodeMask (const osg::Node &node) const
| Method to called by Node and its subclass' Node::accept() method, if the result is true it is used to cull operations of nodes and their subgraphs.
void | setTraversalMode (TraversalMode mode)
| Set the traversal mode for Node::traverse() to use when deciding which children of a node to traverse.
TraversalMode | getTraversalMode () const
| Get the traversal mode.
void | setUserData (Referenced *obj)
| Set user data, data must be subclased from Referenced to allow automatic memory handling.
Referenced * | getUserData ()
| Get user data.
const Referenced * | getUserData () const
| Get const user data.
void | traverse (Node &node)
| Method for handling traversal of a nodes.
void | pushOntoNodePath (Node *node)
| Method called by osg::Node::accept() method before a call to the NodeVisitor::apply(..).
void | popFromNodePath ()
| Method called by osg::Node::accept() method after a call to NodeVisitor::apply(..).
NodePath & | getNodePath ()
| Get the non const NodePath from the top most node applied down to the current Node being visited.
const NodePath & | getNodePath () const
| Get the const NodePath from the top most node applied down to the current Node being visited.
virtual osg::Vec3 | getEyePoint () const
| Get the eye point in local coordinates.
virtual float | getDistanceToEyePoint (const Vec3 &, bool) const
| Get the distance from a point to the eye point, distance value in local coordinate system.
virtual float | getDistanceFromEyePoint (const Vec3 &, bool) const
| Get the distance of a point from the eye point, distance value in the eye coordinate system.
virtual void | apply (Node &node)
virtual void | apply (Geode &node)
virtual void | apply (Billboard &node)
virtual void | apply (Group &node)
virtual void | apply (ProxyNode &node)
virtual void | apply (Projection &node)
virtual void | apply (CoordinateSystemNode &node)
virtual void | apply (ClipNode &node)
virtual void | apply (TexGenNode &node)
virtual void | apply (LightSource &node)
virtual void | apply (Transform &node)
virtual void | apply (CameraNode &node)
virtual void | apply (CameraView &node)
virtual void | apply (MatrixTransform &node)
virtual void | apply (PositionAttitudeTransform &node)
virtual void | apply (Switch &node)
virtual void | apply (Sequence &node)
virtual void | apply (LOD &node)
virtual void | apply (PagedLOD &node)
virtual void | apply (ClearNode &node)
virtual void | apply (OccluderNode &node)
void | setDatabaseRequestHandler (DatabaseRequestHandler *handler)
| Set the handler for database requests.
DatabaseRequestHandler * | getDatabaseRequestHandler ()
| Get the handler for database requests.
const DatabaseRequestHandler * | getDatabaseRequestHandler () const
| Get the const handler for database requests.
## Protected Attributes
VisitorType | _visitorType
int | _traversalNumber
ref_ptr< FrameStamp > | _frameStamp
TraversalMode | _traversalMode
Node::NodeMask | _traversalMask
Node::NodeMask | _nodeMaskOverride
NodePath | _nodePath
ref_ptr< Referenced > | _userData
ref_ptr< DatabaseRequestHandler > | _databaseRequestHandler

## Detailed Description

Visitor for type safe operations on osg::Nodes.

Based on GOF's Visitor pattern. The NodeVisitor is useful for developing type safe operations to nodes in the scene graph (as per Visitor pattern), and adds to this support for optional scene graph traversal to allow operations to be applied to whole scenes at once. The Visitor pattern uses a technique of double dispatch as a mechanism to call the appropriate apply(..) method of the NodeVisitor. To use this feature one must use the Node::accept(NodeVisitor) which is extended in each Node subclass, rather than the NodeVisitor apply directly. So use root->accept(myVisitor); instead of myVisitor.apply(*root). The later method will bypass the double dispatch and the appropriate NodeVisitor::apply(..) method will not be called.

## Member Enumeration Documentation

enum osg::NodeVisitor::TraversalMode

  | Enumeration values:
  TRAVERSE_NONE |
  TRAVERSE_PARENTS |
  TRAVERSE_ALL_CHILDREN |
  TRAVERSE_ACTIVE_CHILDREN |

enum osg::NodeVisitor::VisitorType

  | Enumeration values:
  NODE_VISITOR |
  UPDATE_VISITOR |
  EVENT_VISITOR |
  COLLECT_OCCLUDER_VISITOR |
  CULL_VISITOR |

## Constructor & Destructor Documentation

osg::NodeVisitor::NodeVisitor | ( | TraversalMode | tm = TRAVERSE_NONE | ) |

osg::NodeVisitor::NodeVisitor | ( | VisitorType | type,
|  | TraversalMode | tm = TRAVERSE_NONE
| ) |

virtual osg::NodeVisitor::~NodeVisitor | ( |  | ) | `[virtual]`

## Member Function Documentation

virtual void osg::NodeVisitor::apply | ( | OccluderNode & | node | ) | `[inline, virtual]`

| Reimplemented in osg::CollectOccludersVisitor, osgGA::EventVisitor, osgUtil::CullVisitor, and osgUtil::UpdateVisitor.

virtual void osg::NodeVisitor::apply | ( | ClearNode & | node | ) | `[inline, virtual]`

| Reimplemented in osgUtil::CullVisitor.

virtual void osg::NodeVisitor::apply | ( | PagedLOD & | node | ) | `[inline, virtual]`

virtual void osg::NodeVisitor::apply | ( | LOD & | node | ) | `[inline, virtual]`

| Reimplemented in osg::CollectOccludersVisitor, osgGA::EventVisitor, osgSim::InsertImpostorsVisitor, osgUtil::CullVisitor, osgUtil::IntersectVisitor, osgUtil::Optimizer::CombineLODsVisitor, and osgUtil::UpdateVisitor.

virtual void osg::NodeVisitor::apply | ( | Sequence & | node | ) | `[inline, virtual]`

virtual void osg::NodeVisitor::apply | ( | Switch & | node | ) | `[inline, virtual]`

| Reimplemented in osg::CollectOccludersVisitor, osgGA::EventVisitor, osgUtil::CullVisitor, osgUtil::IntersectVisitor, and osgUtil::UpdateVisitor.

virtual void osg::NodeVisitor::apply | ( | PositionAttitudeTransform & | node | ) | `[inline, virtual]`

virtual void osg::NodeVisitor::apply | ( | MatrixTransform & | node | ) | `[inline, virtual]`

| Reimplemented in osgUtil::Optimizer::CombineStaticTransformsVisitor.

virtual void osg::NodeVisitor::apply | ( | CameraView & | node | ) | `[inline, virtual]`

virtual void osg::NodeVisitor::apply | ( | CameraNode & | node | ) | `[inline, virtual]`

| Reimplemented in osgUtil::CullVisitor.

virtual void osg::NodeVisitor::apply | ( | Transform & | node | ) | `[inline, virtual]`

| Reimplemented in osg::CollectOccludersVisitor, osgGA::EventVisitor, osgUtil::CullVisitor, osgUtil::IntersectVisitor, osgUtil::Optimizer::FlattenStaticTransformsVisitor, osgUtil::Optimizer::RemoveRedundantNodesVisitor, and osgUtil::UpdateVisitor.

virtual void osg::NodeVisitor::apply | ( | LightSource & | node | ) | `[inline, virtual]`

| Reimplemented in osgGA::EventVisitor, osgUtil::CullVisitor, and osgUtil::UpdateVisitor.

virtual void osg::NodeVisitor::apply | ( | TexGenNode & | node | ) | `[inline, virtual]`

| Reimplemented in osgUtil::CullVisitor.

virtual void osg::NodeVisitor::apply | ( | ClipNode & | node | ) | `[inline, virtual]`

| Reimplemented in osgUtil::CullVisitor.

virtual void osg::NodeVisitor::apply | ( | CoordinateSystemNode & | node | ) | `[inline, virtual]`

virtual void osg::NodeVisitor::apply | ( | Projection & | node | ) | `[inline, virtual]`

| Reimplemented in osg::CollectOccludersVisitor, osgGA::EventVisitor, osgUtil::CullVisitor, and osgUtil::UpdateVisitor.

virtual void osg::NodeVisitor::apply | ( | ProxyNode & | node | ) | `[inline, virtual]`

| Reimplemented in osgUtil::Optimizer::FlattenStaticTransformsVisitor, and osgUtil::Optimizer::RemoveLoadedProxyNodesVisitor.

virtual void osg::NodeVisitor::apply | ( | Group & | node | ) | `[inline, virtual]`

| Reimplemented in osgGA::EventVisitor, osgSim::InsertImpostorsVisitor, osgUtil::CullVisitor, osgUtil::IntersectVisitor, osgUtil::Optimizer::RemoveEmptyNodesVisitor, osgUtil::Optimizer::RemoveRedundantNodesVisitor, osgUtil::Optimizer::SpatializeGroupsVisitor, and osgUtil::UpdateVisitor.

virtual void osg::NodeVisitor::apply | ( | Billboard & | node | ) | `[inline, virtual]`

| Reimplemented in osgGA::EventVisitor, osgUtil::CullVisitor, osgUtil::IntersectVisitor, osgUtil::Optimizer::FlattenStaticTransformsVisitor, osgUtil::Optimizer::MergeGeometryVisitor, and osgUtil::UpdateVisitor.

virtual void osg::NodeVisitor::apply | ( | Geode & | node | ) | `[inline, virtual]`

| Reimplemented in osgDB::SharedStateManager, osgGA::EventVisitor, osgUtil::CullVisitor, osgUtil::DisplayRequirementsVisitor, osgUtil::GLObjectsVisitor, osgUtil::IntersectVisitor, osgUtil::Optimizer::FlattenStaticTransformsVisitor, osgUtil::Optimizer::RemoveEmptyNodesVisitor, osgUtil::Optimizer::TesselateVisitor, osgUtil::Optimizer::StateVisitor, osgUtil::Optimizer::CheckGeometryVisitor, osgUtil::Optimizer::MergeGeometryVisitor, osgUtil::Optimizer::TextureVisitor, osgUtil::Simplifier, osgUtil::SmoothingVisitor, osgUtil::TriStripVisitor, and osgUtil::UpdateVisitor.

virtual void osg::NodeVisitor::apply | ( | Node & | node | ) | `[inline, virtual]`

| Reimplemented in osg::CollectOccludersVisitor, osgDB::SharedStateManager, osgGA::EventVisitor, osgSim::InsertImpostorsVisitor, osgUtil::CullVisitor, osgUtil::DisplayRequirementsVisitor, osgUtil::GLObjectsVisitor, osgUtil::IntersectVisitor, osgUtil::Optimizer::FlattenStaticTransformsVisitor, osgUtil::Optimizer::StateVisitor, osgUtil::Optimizer::CopySharedSubgraphsVisitor, osgUtil::Optimizer::TextureVisitor, and osgUtil::UpdateVisitor.

const DatabaseRequestHandler* osg::NodeVisitor::getDatabaseRequestHandler | ( |  | ) | const`[inline]`

| Get the const handler for database requests.

DatabaseRequestHandler* osg::NodeVisitor::getDatabaseRequestHandler | ( |  | ) | `[inline]`

| Get the handler for database requests.

virtual float osg::NodeVisitor::getDistanceFromEyePoint | ( | const Vec3 & | ,
|  | bool |
| ) | const`[inline, virtual]`

| Get the distance of a point from the eye point, distance value in the eye coordinate system. Note, not all NodeVisitor implement this method, it is mainly cull visitors which will implement. If the getDistanceFromEyePoint(pos) is not implemented than a default value of 0.0 is returned. Reimplemented in osg::CollectOccludersVisitor.

virtual float osg::NodeVisitor::getDistanceToEyePoint | ( | const Vec3 & | ,
|  | bool |
| ) | const`[inline, virtual]`

| Get the distance from a point to the eye point, distance value in local coordinate system. Note, not all NodeVisitor implement this method, it is mainly cull visitors which will implement. If the getDistanceFromEyePoint(pos) is not implemented then a default value of 0.0 is returned. Reimplemented in osg::CollectOccludersVisitor.

virtual osg::Vec3 osg::NodeVisitor::getEyePoint | ( |  | ) | const`[inline, virtual]`

| Get the eye point in local coordinates. Note, not all NodeVisitor implement this method, it is mainly cull visitors which will implement. Reimplemented in osgUtil::CullVisitor, and osgUtil::IntersectVisitor.

const FrameStamp* osg::NodeVisitor::getFrameStamp | ( |  | ) | const`[inline]`

| Get the FrameStamp that this traversal is associated with.

Node::NodeMask osg::NodeVisitor::getNodeMaskOverride | ( |  | ) | const`[inline]`

| Get the NodeMaskOverride mask.

const NodePath& osg::NodeVisitor::getNodePath | ( |  | ) | const`[inline]`

| Get the const NodePath from the top most node applied down to the current Node being visited.

NodePath& osg::NodeVisitor::getNodePath | ( |  | ) | `[inline]`

| Get the non const NodePath from the top most node applied down to the current Node being visited.

Node::NodeMask osg::NodeVisitor::getTraversalMask | ( |  | ) | const`[inline]`

| Get the TraversalMask.

TraversalMode osg::NodeVisitor::getTraversalMode | ( |  | ) | const`[inline]`

| Get the traversal mode.

int osg::NodeVisitor::getTraversalNumber | ( |  | ) | const`[inline]`

| Get the traversal number. Typically used to denote the frame count.

const Referenced* osg::NodeVisitor::getUserData | ( |  | ) | const`[inline]`

| Get const user data.

Referenced* osg::NodeVisitor::getUserData | ( |  | ) | `[inline]`

| Get user data.

VisitorType osg::NodeVisitor::getVisitorType | ( |  | ) | const`[inline]`

| Get the VisitorType.

void osg::NodeVisitor::popFromNodePath | ( |  | ) | `[inline]`

| Method called by osg::Node::accept() method after a call to NodeVisitor::apply(..). Note, the user does not typically call popFromNodePath() as it will be called automatically by the Node::accept() method.

void osg::NodeVisitor::pushOntoNodePath | ( | Node * | node | ) | `[inline]`

| Method called by osg::Node::accept() method before a call to the NodeVisitor::apply(..). The back of the list will, therefore, be the current node being visited inside the apply(..), and the rest of the list will be the parental sequence of nodes from the top most node applied down the graph to the current node. Note, the user does not typically call pushNodeOnPath() as it will be called automatically by the Node::accept() method.

virtual void osg::NodeVisitor::reset | ( |  | ) | `[inline, virtual]`

| Method to call to reset visitor. Useful if your visitor accumulates state during a traversal, and you plan to reuse the visitor. To flush that state for the next traversal: call reset() prior to each traversal. Reimplemented in osg::CollectOccludersVisitor, osgGA::EventVisitor, osgSim::InsertImpostorsVisitor, osgUtil::CullVisitor, osgUtil::IntersectVisitor, osgUtil::Optimizer::StateVisitor, and osgUtil::UpdateVisitor.

void osg::NodeVisitor::setDatabaseRequestHandler | ( | DatabaseRequestHandler * | handler | ) | `[inline]`

| Set the handler for database requests.

void osg::NodeVisitor::setFrameStamp | ( | FrameStamp * | fs | ) | `[inline]`

| Set the FrameStamp that this traversal is associated with.

void osg::NodeVisitor::setNodeMaskOverride | ( | Node::NodeMask | mask | ) | `[inline]`

| Set the NodeMaskOverride mask. Used in validNodeMask() to determine whether to operate on a node or its subgraph, by OR'ing NodeVisitor::_nodeMaskOverride with the Node's own Node::_nodeMask. Typically used to force on nodes which may have been switched off by their own Node::_nodeMask.

void osg::NodeVisitor::setTraversalMask | ( | Node::NodeMask | mask | ) | `[inline]`

| Set the TraversalMask of this NodeVisitor. The TraversalMask is used by the NodeVisitor::validNodeMask() method to determine whether to operate on a node and its subgraph. validNodeMask() is called automatically in the Node::accept() method before any call to NodeVisitor::apply(), apply() is only ever called if validNodeMask returns true. Note, if NodeVisitor::_traversalMask is 0 then all operations will be switched off for all nodes. Whereas setting both _traversalMask and _nodeMaskOverride to 0xffffffff will allow a visitor to work on all nodes regardless of their own Node::_nodeMask state.

void osg::NodeVisitor::setTraversalMode | ( | TraversalMode | mode | ) | `[inline]`

| Set the traversal mode for Node::traverse() to use when deciding which children of a node to traverse. If a NodeVisitor has been attached via setTraverseVisitor() and the new mode is not TRAVERSE_VISITOR then the attached visitor is detached. Default mode is TRAVERSE_NONE.

void osg::NodeVisitor::setTraversalNumber | ( | int | fn | ) | `[inline]`

| Set the traversal number. Typically used to denote the frame count.

void osg::NodeVisitor::setUserData | ( | Referenced * | obj | ) | `[inline]`

| Set user data, data must be subclased from Referenced to allow automatic memory handling. If your own data isn't directly subclassed from Referenced then create an adapter object which points to your own objects and handles the memory addressing.

void osg::NodeVisitor::setVisitorType | ( | VisitorType | type | ) | `[inline]`

| Set the VisitorType, used to distinguish different visitors during traversal of the scene, typically used in the Node::traverse() method to select which behaviour to use for different types of traversal/visitors.

void osg::NodeVisitor::traverse | ( | Node & | node | ) | `[inline]`

| Method for handling traversal of a nodes. If you intend to use the visitor for actively traversing the scene graph then make sure the accept() methods call this method unless they handle traversal directly.

bool osg::NodeVisitor::validNodeMask | ( | const osg::Node & | node | ) | const`[inline]`

| Method to called by Node and its subclass' Node::accept() method, if the result is true it is used to cull operations of nodes and their subgraphs. Return true if the result of a bit wise and of the NodeVisitor::_traversalMask with the bit or between NodeVistor::_nodeMaskOverride and the Node::_nodeMask. default values for _traversalMask is 0xffffffff, _nodeMaskOverride is 0x0, and osg::Node::_nodeMask is 0xffffffff.

## Member Data Documentation

ref_ptr<DatabaseRequestHandler> osg::NodeVisitor::_databaseRequestHandler`[protected]`

ref_ptr<FrameStamp> osg::NodeVisitor::_frameStamp`[protected]`

Node::NodeMask osg::NodeVisitor::_nodeMaskOverride`[protected]`

NodePath osg::NodeVisitor::_nodePath`[protected]`

Node::NodeMask osg::NodeVisitor::_traversalMask`[protected]`

TraversalMode osg::NodeVisitor::_traversalMode`[protected]`

int osg::NodeVisitor::_traversalNumber`[protected]`

ref_ptr<Referenced> osg::NodeVisitor::_userData`[protected]`

VisitorType osg::NodeVisitor::_visitorType`[protected]`

The documentation for this class was generated from the following file:

- NodeVisitor